program testapache;

{$linklib apr-1}
{$linklib aprutil-1}

uses sysutils,httpd,fpapache;

Type

  { TMyApp }

  TMyApp = class(TApacheApplication)
    Function CreateRequestrec : PRequest_rec;
    Procedure FreeRequestRec(p : PRequest_rec);
    Function CreateRequest(P : PRequest_rec) : TApacheRequest;
    Procedure DoTest;
  end;

{ TMyApp }

Function ap_log_error(p : prequest_rec) : integer ;cdecl; public name 'ap_log_error';

begin
end;

Function ap_os_escape_path(P: prequest_rec) : pchar; cdecl; public name 'ap_os_escape_path';

begin
  Writeln('ap_os_escape_path');
end;

Function ap_get_remote_host(P: prequest_rec) : pchar; cdecl; public name 'ap_get_remote_host';

begin
  Writeln('ap_get_remote_host');
end;

Function ap_hook_handler(P : Pointer; PBef,Paf : PPchar; When : Integer) : pchar; cdecl; public name 'ap_hook_handler';

begin
  Writeln('ap_hook_handler');
end;

Function ap_get_server_port(P: Prequest_rec) : pchar; cdecl; public name 'ap_get_server_port';

begin
  Writeln('ap_get_server_port');
end;

Function ap_rwrite(P : prequest_rec; buf : Pchar; Count : Integer) : integer; cdecl; public name 'ap_rwrite';

begin
  Writeln('ap_rwrite');
end;

Function ap_setup_client_block(P : prequest_rec) : integer; cdecl; public name 'ap_setup_client_block';

begin
  Writeln('ap_setup_client_block');
end;

Function ap_should_client_block(P : prequest_rec) : integer; cdecl; public name 'ap_should_client_block';

begin
  Writeln('ap_should_client_block');
end;

Function ap_get_client_block(P : prequest_rec) : integer; cdecl; public name 'ap_get_client_block';

begin
  Writeln('ap_get_client_block');
end;

var
  NilArr : Array[0..1] of Pchar = ('something:else',Nil);

function TMyApp.CreateRequestrec: PRequest_rec;
begin
  Result:=New(PRequest_rec);
  Result^.HostName:=StrNew('localhost');
  Result^.unparsed_uri:=strnew('/path1/path2/path3/path4/path5');
  result^.path_info:=Strnew('/path1/path2/path3');
  Result^.headers_in:=@NilArr[0]
end;

procedure TMyApp.FreeRequestRec(p: PRequest_rec);
begin
  FreeMem(P^.HostName);
  FreeMem(P^.unparsed_uri);
  FreeMem(P^.path_info);
  FreeMem(P);
end;


function TMyApp.CreateRequest(P : PRequest_rec) : TApacheRequest;

begin
  Result:=TApacheRequest.CreateReq(Self,P);
end;

procedure TMyApp.DoTest;

var
  P : PRequest_Rec;
  R : TApacheRequest;
  S : String;
  
begin
  P:=CreateRequestRec;
  Try
    R:=CreateRequest(P);
    Try
      Writeln('Pathinfo before : ',R.PathInfo);
      S:=GetModuleName(R);
      Writeln('Module name :',S);
      Writeln('Pathinfo after Getmodule name :',R.PathInfo);
    Finally
      R.Free;
    end;
  Finally
    FreeRequestRec(P);
  end;
end;

Var
  A : TMyApp;
  

begin
  A:=TMyApp.Create(Nil);
  Try
    A.DoTest;
  Finally
    A.Free;
  end;
end.
